<?php

// ---------------------------------------------------------------------------
//
// PIVOT - LICENSE:
//
// This file is part of Pivot. Pivot and all its parts are licensed under 
// the GPL version 2. see: http://www.pivotlog.net/help/help_about_gpl.php
// for more information.
//
// ---------------------------------------------------------------------------


	if(!defined('INPIVOT')){
		exit;
	}
	MinLevel(3);
	
	function startAdmin() {
		global $Pivot_Vars, $adminInternal;
		if(isset($adminInternal[$Pivot_Vars['do']])) {
			if(function_exists($adminInternal[$Pivot_Vars['do']])) {
				$adminInternal[$Pivot_Vars['do']]();
			}else{
				ErrorOut('Function: <i>'.$adminInternal[$Pivot_Vars['do']].'</i> does not exist in pv_admin.php.');	
			}
		} else {
			adminMain();	
		}		
	}
	
	function adminMain() {
		PageHeader('Admin Overview', 1);
		PageAnkeiler(lang('userbar','admin') . ' &raquo; ' . lang('userbar','admin_title'));

		$admin_funcs = array(
			array(lang('adminbar','seeusers'), 'seeusers', lang('admin','seeusers')),
			array(lang('adminbar','categories'), 'categories' , lang('adminbar','categories_title') ),
			array(lang('adminbar','blogs'), 'blogs', lang('admin','blogs')),
			array(lang('adminbar','filemappings'), 'filemappings', lang('adminbar','filemappings_title')),
			array(lang('adminbar','templates'), 'templates', lang('admin','templates')),
			array(lang('adminbar','seeconfig'), 'seeconfig', lang('admin','seeconfig')),
			array(lang('adminbar','maintenance'), 'maintenance', lang('admin','maintenance'))
		);
		echo '<div style="text-align: center">';
		DispPage($admin_funcs);	
		echo '</div>';	
			
		PageFooter();		
	}	
	



function see_config() {
	global $config_array;
	PageHeader('Edit Config', 1);
	PageAnkeiler(lang('userbar','admin') . ' &raquo; ' . lang('adminbar','seeconfig_title'));

	StartForm('save_config', 1);
	StartTable();

	DisplaySettings(get_config());
	EndForm(lang('config','save'), 1);		
	PageFooter();
}


function see_categories($err=0) {
	global $Cfg, $Pivot_Vars;
	PageHeader(lang('adminbar','categories_title'), 1, 'switch');
	PageAnkeiler(lang('userbar','admin') . ' &raquo; ' . lang('adminbar','categories_title'));
	
	$cat_page = array();
	
	$cats= cfg_cats();

	foreach($cats as $cat){
		$allowed = implode(", ", explode("|", $Cfg['cat-'. $cat]));
		$title = sprintf("%s </a>(users: %s)</i>", $cat, $allowed);
		array_push($cat_page, array($title, 'cat_edit&cat='.urlencode($cat), sprintf(lang('category','edit_who'), $cat)));	
	}
	
	DispPage($cat_page);
	if($err==1){
		$err_msg = lang('category','same_name');
	}elseif($err==2){
		$err_msg = lang('category','need_name');	
	}

	StartForm('save_cat', 1);
	StartTable();
	GenSetting('', lang('category','make_new'), '', 8, '', 2);
	GenSetting('cat_name', lang('category','name'), $err_msg, 0, $Pivot_Vars['cat_name']);
	foreach(explode("|", $Cfg['users']) as $user){
		$rvar[] = $user;
		$rvar[] = $user;	
	}
	$cols = (count(explode("|", $Cfg['users'])) -2);
	if($cols < 4){
		$cols = 4;	
	}
	GenSetting('allowed', lang('category','users'), lang('category','canpost'), 4, $rvar, $cols, 'multiple');	
	GenSetting('new','','',7,'1');
	// stuff goes here..
	echo '</table>';
	EndForm(lang('category','create'));
	PageFooter();
}


	function edit_category() {
		global $Cfg, $Pivot_Vars;
		PageHeader(lang('adminbar','categories_title'), 1, 'switch');
		PageAnkeiler(lang('userbar','admin') . ' &raquo; ' . lang('adminbar','categories_title'));
	
		//get the list of people that can post..
		$overall = explode("|", $Cfg['users']);
		$allowed = explode("|", $Cfg['cat-'. $Pivot_Vars['cat']]);
		foreach($overall as $cow){
			if(!in_array($cow, $allowed)){
				$denied[] = $cow;
			}	
		}

		StartForm('save_cat', 1, 'onSubmit="selectAll()"');
		GenSetting('new','','',7,'0');
		GenSetting('name','','',7, $Pivot_Vars['cat']);
		StartTable('', 3);
		GenSetting('heading', lang('category','edit'), '', 8, '', '3', '');					

		echo '<tr><td width="40%" style="align: center";><b>' . lang('category','allowed') .'</b><br />';
		echo '<select name="allowed[]" id="allowed" multiple size="5" style="width: 140;" onDblClick="moveOver(this.form.allowed,this.form.denied)">';
		foreach($allowed as $name){
			if(strlen($name) > 2){
				echo '<option value="'.$name.'">'.$name.'</option>';
			}
			
		}	
		echo '</select>';
		echo '</td><td width="10%"><br /></td><td width="40%" style="align: center";><b>' . lang('category','denied') .'</b><br />';
		echo '<select name="denied[]" id="denied" multiple size="5" style="width: 140;" onDblClick="moveOver(this.form.denied,this.form.allowed)">';
		foreach($denied as $name){
			if(strlen($name) > 2){
				echo '<option value="'.$name.'">'.$name.'</option>';
			}
		}	
		echo '</select>';
		echo '</td></tr><tr><td width="40%" style="align: center";>';
		echo '<input type="button" value="&gt;&gt; ' . lang('category','deny') .'" onclick="moveOver(this.form.allowed,this.form.denied)">';
		echo '</td><td width="10%"><br /></td><td width="40%" style="align: center";>'; 
		echo '<input type="button" value="&lt;&lt; ' . lang('category','allow') .'" onclick="moveOver(this.form.denied,this.form.allowed)">';
		echo '</td></tr>';
		echo "<tr><td width='85%' colspan='3' style='padding-left: 18%; padding-bottom: 7px;'>".lang('category', 'canpost')."</td></tr>";
		echo '<tr><td colspan="3" align="right">';
		EndForm(lang('category','edit'));
		echo '</td></tr>';	
		echo '</table><br /><br />';

		echo '<table cellspacing="0" cellpadding="2" border="0" width="480" class="sTable">'."\n";

		StartForm('del_cat', 1);
		GenSetting('heading', lang('category','delete'), '', 8, '', '2', '');					
		GenSetting('delete', lang('delete'), lang('category', 'delete_desc'), 3, 'yn', '', '0');
		GenSetting('cat', '', '', 7, $Pivot_Vars['cat']);
		echo "<tr><td colspan='3' align='right'>";
		EndForm(lang('category', 'delete'));
		echo '</td></tr>';	
		echo '</table>';		
		
		// stuff goes here..

		PageFooter();
	}
	
	function save_categories(){
		global $Cfg, $Pivot_Vars;		
		if($Pivot_Vars['new']==1){
			// make sure new cat does not contain any exotic characters.
			$Pivot_Vars['cat_name'] = safe_string($Pivot_Vars['cat_name']);
			
			if($Cfg['cat-' . $Pivot_Vars['cat_name']]){
				see_categories(1);
			}elseif(strlen($Pivot_Vars['cat_name']) < 1){
				see_categories(2);	
			}else{
				@$Cfg['cat-' . $Pivot_Vars['cat_name']] = implode("|", $Pivot_Vars['allowed']);
				$Cfg['cats'] .= "|". $Pivot_Vars['cat_name'];
				see_categories();
			}	
		}else{
			@$Cfg['cat-' . $Pivot_Vars['name']] = implode("|", $Pivot_Vars['allowed']);
			$cats = cfg_cats();

			$cats[] = $Pivot_Vars['name'];
			unset($category['']);
			$Cfg['cats'] =  implode("|", array_unique($cats));
			see_categories();
		}	
		
	}
	
	function delete_category(){
		global $Cfg, $Pivot_Vars;
		
			if($Pivot_Vars['confirmed']!=1){
				$vars = array('category', $Pivot_Vars['cat']);
				ConfirmPage(lang('category','delete'), $vars, sprintf(lang('category','delete_message'), $Pivot_Vars['username']));	
			}else{
				$cats = cfg_cats();
				foreach($cats as $cat){
					if($cat != $Pivot_Vars['category']){
						$del_cat[] = $cat;
					}
				}
				$Cfg['cats'] = implode($del_cat, "|");
				unset($Cfg['cat-' . $Pivot_Vars['category']]);
				see_categories();
			}		
		
		
	}
	
	function regen() {
		global $config_array, $db, $done_archives, $totalfiles, $archive_array_next, $archive_array_prev, $Pivot_Vars;
		PageHeader(lang('adminbar','regen_title'), 1);
		PageAnkeiler(lang('userbar','admin') . ' &raquo; ' . lang('adminbar','regen_title'));

		// stuff goes here..
		include_once("modules/module_parser.php");

		$db = new db();
	
		// also force the archive index file to be updated
		@unlink('db/ser-archives.php');

		// ugly hack, to get a big slice of mem back..
		$entries_arr = $db->getcodes_range("0000-00-00-00-00", "2010-01-01-00-00","","", FALSE);
		
		$totalfiles = 0;
		$count=0;

		if (isset($Pivot_Vars['count'])) {
			$count = $Pivot_Vars['count'];
			$totalfiles = $Pivot_Vars['totalfiles'];
			reset($entries_arr);
			do {
				next($entries_arr);
				$key=key($entries_arr);
				//echo "(k $key)";
			} while ($key < $Pivot_Vars['count']);
		}


		do {
			
			$key=key($entries_arr);
			$loopentry = current($entries_arr);

			//echo "<small>($key)</small>";
			generate_pages($loopentry, TRUE, TRUE, TRUE);

			$count++;

			if (($count % 10) == 0) { 
				printf("%1.2f sec: Processed %d entries.."."<br />\n", timetaken('int'), $count);
				flush();
			}

			// server friendly generate all..
			if (timetaken("int")>28) { 
					$myurl = sprintf("index.php?session=%s&menu=admin&func=admin&do=regen&count=%s&totalfiles=%s", $Pivot_Vars['session'], $count, $totalfiles);
					printf('<script> self.location = "%s"; </script>',$myurl);
					die();		
			}

		} while (next($entries_arr));

		printf("<br />A total of <b>%s</b> entries have been processed, and <b>%s</b> files have been created"."<br />\n", $count, $totalfiles);

		echo "<p>Finished!</p>";
		
		PageFooter();
	}
	

	function filemappings() {
		global $Pivot_Vars, $Weblogs;

		PageHeader(lang('adminbar','filemappings'), 1);
		PageAnkeiler(lang('userbar','admin') . ' &raquo; ' . lang('adminbar','filemappings'));

		echo "<p>" . wordwrap( lang('adminbar','filemappings_desc'), 90, '<br />'). "</p>";

		foreach ($Weblogs as $key => $thislog) {
			printf("<br /><h2>Weblog '%s' (internal name: '%s')</h2>", $thislog['name'], $key);
	
			// Frontpage..
			$name = $thislog['front_path'] . $thislog['front_filename'];
			printf("<br /><h3>Frontpage: </h3>");
			printf("<p>The Frontpage will be written to file: <span class='filename'>%s</span>", $name);
			printf(" (<a href='%s' target='_blank'>view</a>)<br />", $name);
			testfile($name);
			 
			$name = 'templates/'.$thislog['front_template'];
			printf("It uses the template file: <span class='filename'>%s</span>", $name);
			//link : index.php?session=sQ96PR8X9Gts&menu=admin&func=admin&do=templates&edit=frontpage_template.html
			$link = sprintf("index.php?session=%s&menu=admin&func=admin&do=templates&edit=%s", 
					$Pivot_Vars['session'], $thislog['front_template']);
			printf(" (<a href='%s' target='_blank'>edit</a>)<br />", $link);
			//testfile($name);

			echo "</p>";
			
			// subweblogs..
			
			printf("<p>This weblog has %s subweblogs:<br />\n", count($thislog['sub_weblog']));
			foreach ($thislog['sub_weblog'] as $key => $thissublog) {
				printf("- <b>%s</b> uses template: <span class='filename'>templates/%s</span>", $key, $thissublog['template']);
				$link = sprintf("index.php?session=%s&menu=admin&func=admin&do=templates&edit=%s", 
					$Pivot_Vars['session'], $thissublog['template']);
				printf(" (<a href='%s'>edit</a>)<br />\n", $link);
			}

			echo "</p>";
			
			// Archive..
			$name = $thislog['archive_path'] . $thislog['archive_filename'];
			printf("<br /><h3>Archives: </h3>\n");
			printf("<p>The Archives will be written to files: <span class='filename'>%s</span> ('%%1' is used for the varying date format) <br />\n", $name);
			testfile($name);
			 
			$name = 'templates/'.$thislog['archive_template'];
			printf("It uses the template file: <span class='filename'>%s</span>\n", $name);
			//link : index.php?session=sQ96PR8X9Gts&menu=admin&func=admin&do=templates&edit=frontpage_template.html
			$link = sprintf("index.php?session=%s&menu=admin&func=admin&do=templates&edit=%s", 
					$Pivot_Vars['session'], $thislog['archive_template']);
			printf(" (<a href='%s' target='_blank'>edit</a>)<br />\n", $link);
			//testfile($name);

			echo "</p>";
			
			// Single entries..
			$name = $thislog['entry_path'] . $thislog['entry_filename'];
			printf("<br /><h3>Single Entries: </h3>");
			if ($thislog['live_entries']==0) {
				printf("<p>Single entry pages be written to file: <span class='filename'>%s</span> ('%%1' is used for the varying entry format) <br />\n", $name);
				testfile($name);
			} else {
				printf("<p>Single entry pages are created dynamically.<br />\n");
			}
			 
			$name = 'templates/'.$thislog['entry_template'];
			printf("It uses the template file: <span class='filename'>%s</span>", $name);
			//link : index.php?session=sQ96PR8X9Gts&menu=admin&func=admin&do=templates&edit=frontpage_template.html
			$link = sprintf("index.php?session=%s&menu=admin&func=admin&do=templates&edit=%s", 
					$Pivot_Vars['session'], $thislog['entry_template']);
			printf(" (<a href='%s' target='_blank'>edit</a>)<br />", $link);
			//testfile($name);

			echo "</p>";


			// Feeds..
			$name = $thislog['entry_path'] . $thislog['entry_filename'];
			printf("<br /><h3>Syndication Feeds: </h3>");
			if ($thislog['rss']==0) {
				echo "<p>No Feeds are created by this weblog.</p>";
			} else {
				if ($thislog['rss_filename']!="") {
					$name = $thislog['rss_path'] . $thislog['rss_filename'];
					printf("<p>The RSS feed will be written to file: <span class='filename'>%s</span>\n", $name);
					printf(" (<a href='%s' target='_blank'>view</a>)<br />", $name);
					testfile($name);
				} else {
					echo "<p>No RSS feed will be created, because no name was set in the weblog's config</p>";
				}

				if ($thislog['atom_filename']!="") {
					$name = $thislog['rss_path'] . $thislog['atom_filename'];
					printf("<p>The Atom feed will be written to file: <span class='filename'>%s</span>\n", $name);
					printf(" (<a href='%s' target='_blank'>view</a>)<br />", $name);
					testfile($name);
				} else {
					echo "<p>No RSS feed will be created, because no name was set in the weblog's config</p>";
				}

			}



		}


	}


	
	// CHANGES: PAUL 04/05/03
	function templates() {
		global $Pivot_Vars;

		PageHeader(lang('adminbar','templates_title'), 1);
		PageAnkeiler(lang('userbar','admin') . ' &raquo; ' . lang('adminbar','templates_title'));

		// if there is an 'action' to do
		if (isset($Pivot_Vars['doaction'])) {
			files_action($Pivot_Vars['action'], $Pivot_Vars['check']);
		}

		if(isset($Pivot_Vars['edit']) && !isset($Pivot_Vars['changes'])) {
			edit_template();
		} else if(isset($Pivot_Vars['changes'])) {
			save_template();
		} else if(isset($Pivot_Vars['rollback'])) {
			rollback_template();
		} else if(isset($Pivot_Vars['create'])) {
			create_template();
		} else {
			show_templates();
		}
	}


	function show_templates() {
		global $config_array, $Pivot_Vars;

		DispPage(array(
				array(lang('templates', 'create_template'), 'templates&create=true', lang('templates', 'create_template_info')),
		));

		$myDeleteUrl =sprintf("index.php?session=%s&menu=admin&func=admin&do=templates&doaction=1", $Pivot_Vars['session']);
		printf("<form name='form1' method='post' action='%s'>", $myDeleteUrl);

		echo '<table cellspacing="0" class="tabular_border">';

		printf('<tr class="tabular_header"><td>&nbsp;</td><td width="200">%s</td><td width="100">%s</td><td>%s</td><td>%s</td><td>%s</td></tr>', lang('upload','filename') , lang('templates','rollback') , lang('upload','date') , lang('upload','filesize') ,lang('adminbar','description'));

		$d = opendir('templates/') or die(lang('error','path_open'));
		while(false !== ($f = readdir($d))) {
			$files[] = $f;
		}

		sort($files); 

		foreach ($files as $f) {
			if(is_file('templates/'.$f)) {
				if(preg_match('/(.*)(html|css|php|htm|txt)$/i','templates/'.$f)) {
					$fs = round(filesize('templates/'.$f)/1024);
					$fd = format_date(date('Y-m-d-H-i',filemtime('templates/'.$f)),'%day%-%month%-%ye% %hour24%:%minute%');
					
					if(file_exists('templates/'.$f.'.cache')) {
						$rollback_date = format_date(date('Y-m-d-H-i',filemtime('templates/'.$f.'.cache')),'%day%%month%%ye%%hour24%%minute%');
					} else {
						$rollback_date = '&nbsp;';
					}

					if (!isset($linecount)) {
						$linecount=1;
					} else {
						$linecount++;
					}

					if (($linecount % 2)==0) { 
						$bg_color="tabular_line_even";
					} else {
						$bg_color="tabular_line_odd"; 
					}

					$myUrl = sprintf("index.php?session=%s&menu=admin&func=admin&do=templates&edit=%s",$Pivot_Vars['session'],$f);
					$mySecondUrl = sprintf("index.php?session=%s&menu=admin&func=admin&do=templates&rollback=%s",$Pivot_Vars['session'],$f);

					printf('<tr class="%s">',$bg_color);
					printf("<td><input type='checkbox' name='check[%s]'></td>",$f);
					printf('<td><a href="%s">%s</a></td>',$myUrl,$f);
					printf('<td><a href="%s">%s</a></td>',$mySecondUrl,$rollback_date);
					printf('<td>%s</td>',$fd);
					printf('<td>%d KB</td>',$fs);
					
					$comment = check_for_comment($f);
					if($comment) {
						printf('<td>%s</td>',check_for_comment($f));
					} else {
						printf('<td>%s</td>',lang('templates', 'no_comment'));
					}
				}
			}
		}
		closedir($d);

		print("  <tr class=\"tabular_nav\"><td colspan=7><img src='pics/arrow_ltr.gif' width='29' height='14' border=0 alt=''>");
		echo '<a href="#" onclick=\'setCheckboxes("form1", true); return false;\'>'. lang('forms', 'c_all') .'</a> /';
		echo '<a href="#" onclick=\'setCheckboxes("form1", false); return false;\'>'. lang('forms', 'c_none') .'</a>';
	 	echo '&nbsp;&nbsp;&nbsp;-&nbsp;&nbsp;'. lang('forms', 'with_checked_templates');
		echo '<select name="action" class="input"><option value="" selected>'. lang('forms', 'choose') .'</option><option value="delete">'. lang('forms', 'delete') .'</option></select>';

		echo '&nbsp;&nbsp;<input type="submit" value="'. lang('go') .'" class="button">';
		print("</table></form>");

		PageFooter();
	}

	function check_for_comment($file) {
		if(file_exists('templates/'.$file.'.cache')) {
			$fp = fopen('templates/'.$file.'.cache','rb') or die("<b>$file: </b>".lang('error','file_open'));
			$data = unserialize(stripslashes(fread($fp, filesize('templates/'.$file.'.cache'))));
			fclose($fp);
			if($data[1] != '') {
				return $data[1];
			} else {
				return lang('templates', 'no_comment');
			}
		} else {
			return false;
		}
	}

	function edit_template() {
		global $config_array, $Pivot_Vars;

		$fh = fopen('templates/'.$Pivot_Vars['edit'],'rb+') or die("<b>".$Pivot_Vars['edit'].": </b>".lang('error','file_open'));
		
		if(filesize('templates/'.$Pivot_Vars['edit']) > 0) {
			$s = fread($fh,filesize('templates/'.$Pivot_Vars['edit'])) or die("<b>".$Pivot_Vars['edit'].": </b>".lang('error','file_read'));
		} else {
			$s = '';
		}
		
		$s = str_replace('<textarea','<*textarea',$s);
		$s = str_replace('</textarea>','<*/textarea*>',$s);

		fclose($fh);

		printf("<h2>%s %s</h2><br />",lang('templates','editing'),$Pivot_Vars['edit']);
		printf("<form method=POST action='index.php'>\n",$action);
		printf("<input type='hidden' name='session' value='%s'>",$Pivot_Vars['session']);
		print("<input type='hidden' name='menu' value='admin'>");
		print("<input type='hidden' name='func' value='admin'>");
		print("<input type='hidden' name='do' value='templates'>");
		printf("<input type='hidden' name='edit' value='%s'>",$Pivot_Vars['edit']);
		
		$comment = check_for_comment($Pivot_Vars['edit']);

		if(!$comment) {
			printf("<b>%s</b>%s<input type='text' name='comment' value='%s' class='input' size='50'><br /><br />",lang('templates','comment'),str_repeat('&nbsp;',10),$comment);
			printf("<small>%s</small><br /><br />",lang('templates','comment_note'));
		}

		printf("<textarea name='changes' rows='20' style='width: 98%%'>%s</textarea>",htmlentities($s));
		echo '<br /><br /><input type="submit" value="'. lang('templates','save_changes') .'" class="button">';
		print("</form>");

		PageFooter();
	}

	function pre($arr) {
		echo '<pre>';
		print_r($arr);
		echo '</pre>';
	}


	function save_template() {
		global $config_array, $Pivot_Vars;

		// make sure that we save it in the pivot/templates/ folder..
		$file = basename($Pivot_Vars['edit']);

		$comment = $Pivot_Vars['comment'];
		$changes = $Pivot_Vars['changes'];
		
		// make sure we don't accepts strange filename extensions
		$ext = getextension($file);
		if ( ($ext!='txt') && ($ext!='htm') && ($ext!='html') && ($ext!='css') ) {
			$file = $file.".txt";
		}	
		

		$changes = str_replace('<*textarea','<textarea',$changes);
		$changes = str_replace('<*/textarea*>','</textarea>',$changes);

		// Creating $file.cache'
		// if file doesn't exist yet
		if(!file_exists('templates/'.$file.'.cache')) {
			//echo '-saved '.$file.'.cache-<br />';
			$fp = fopen('templates/'.$file.'.cache','wb') or die("<b>$file: </b>".lang('error','file_open'));
			$data = Array($file,$comment,$changes);

			fwrite($fp,addslashes(serialize($data))) or die(lang('error','file_write'));
			fclose($fp);
		} 
		
		else if(isset($Pivot_Vars['roll'])) {
			//echo '-deleted '.$file.'.cache-<br />';
			unlink('templates/'.$file.'.cache');
		}

		// Saving file
		//echo '-saved '.$file.'-<br />';
		$fh = fopen('templates/'.$file,'wb+') or die("<b>$file: </b>".lang('error','file_open'));
		$changes = stripslashes($changes);

		// Rewind file and save changes
		rewind($fh);
		if(-1 == fwrite($fh,$changes)) { die(lang('error','file_write')); }
		
		ftruncate($fh,ftell($fh)) or die(lang('error','file_write'));
		
		// Close file
		fclose($fh);

		show_templates();
		PageFooter();
	}


	function create_template() {
		global $Pivot_Vars;

		printf("<h2>%s</h2><br />",lang('templates','create'));
		print("<form method=POST action='index.php'>\n");
		printf("<input type='hidden' name='session' value='%s'>",$Pivot_Vars['session']);
		print("<input type='hidden' name='menu' value='admin'>");
		print("<input type='hidden' name='func' value='admin'>");
		print("<input type='hidden' name='do' value='templates'>");
		printf("<b>%s</b>%s<input type='text' name='edit' value='' class='input' size='50'><br /><br />",lang('templates','filename'),str_repeat('&nbsp;',12));
		printf("<b>%s</b>%s<input type='text' name='comment' value='' class='input' size='50'><br /><br />",lang('templates','comment'),str_repeat('&nbsp;',10));
		printf("<small>%s</small><br /><br />",lang('templates','comment_note'));
		printf("<textarea name='changes' rows='20' style='width: 98%%'></textarea>");
		echo '<br /><br /><input type="submit" value="'. lang('templates','save_template') .'" class="button">';
		print("</form>");
	}


	function rollback_template() {
		global $Pivot_Vars;

		$file = $Pivot_Vars['rollback'];

		$fp = fopen('templates/'.$file.'.cache','r') or die("<b>$file: </b>".lang('error','file_open'));
		$fr = fread($fp, filesize('templates/'.$file.'.cache'));

		$data = unserialize(stripslashes($fr));

		$comment = stripslashes($data[1]);
		$changes = stripslashes(stripslashes($data[2]));
		$changes = str_replace('<textarea','<*textarea',$changes);
		$changes = str_replace('</textarea>','<*/textarea*>',$changes);
		
		printf("<h2>%s %s?</h2><br />",lang('templates','rollback'),$data[0]);
		printf("<form method=POST action='index.php'>\n",$action);
		printf("<input type='hidden' name='session' value='%s'>",$Pivot_Vars['session']);
		print("<input type='hidden' name='menu' value='admin'>");
		print("<input type='hidden' name='func' value='admin'>");
		print("<input type='hidden' name='do' value='templates'>");
		print("<input type='hidden' name='roll' value='true'>");
		printf("<input type='hidden' name='edit' value='%s'>",$data[0]);
		printf("<textarea name='changes' rows='20' style='width: 98%%'>%s</textarea>",htmlentities($changes));
		echo '<br /><br /><input type="submit" value="'. lang('templates','save_changes') .'" class="button">';
		print("</form>");
		fclose($fp);
	}

	
	function verify_db() {
		global $config_array;
		PageHeader(lang('adminbar','verifydb_title'), 1);
		PageAnkeiler(lang('userbar','admin') . ' &raquo; ' . lang('adminbar','verifydb_title'));

		// stuff goes here..
		echo "<p>This feature has not been implemented yet.</p>";

		PageFooter();
	}
	
	
	
	function backup() {
		global $config_array;
		PageHeader(lang('adminbar','backup'), 1);
		PageAnkeiler(lang('adminbar','backup') . ' &raquo; ' . lang('adminbar','backup_title'));

		// stuff goes here..
		echo "<p>This feature has not been implemented yet.</p>";

		PageFooter();
	}
	


function save_config() {
	global $Pivot_Vars, $Cfg;

	$config_array = get_config();

	$arraycount = Count($config_array);
	for($i = 0; $i < $arraycount; $i++){
		if($config_array[$i][0] != 'heading') {
			if($config_array[$i][3] == 4){
				$Pivot_Vars[$config_array[$i][0]] = @implode("|", $Pivot_Vars[$config_array[$i][0]]);
				//I just escaped the damn thing because it's a waste of code to add if/else stuff
			}
			$Cfg[$config_array[$i][0]] = $Pivot_Vars[$config_array[$i][0]];
		}
	}	

	// a hack by bob.
	if (isset($Cfg['ping_urls'])) { 
		$Cfg['ping_urls'] = str_replace("\n", "|", $Cfg['ping_urls']); 
		$Cfg['ping_urls'] = str_replace("\r", "", $Cfg['ping_urls']); 
	}

	see_config();				
}



function see_users() {
	global $Pivot_Vars, $Users;
	PageHeader(lang('adminbar','seeusers_title'), 1);
	PageAnkeiler(lang('userbar','admin') . ' &raquo; ' . lang('adminbar','seeusers_title'));
	
	DispPage(array(
			array(lang('userinfo', 'editfields'), 'userfields', lang('userinfo', 'desc_editfields')),
			array(lang('userinfo', 'newuser'), 'new_user', lang('userinfo', 'desc_newuser'))
	));
	
	StartTable();
	GenSetting('', lang('category','users'), '', 8, '', 2);
	foreach($Users as $key => $array) {
		echo '<tr><td width="20%"><b>'.$key.'</b></td>
				<td>';
				if(($Users[$Pivot_Vars['user']]['userlevel'] > $Users[$key]['userlevel']) || $Pivot_Vars['user'] == $key) {
					MakeLink(array('func'=>'admin', 'do'=>'edituser', 'edituser'=>$key));
					echo lang('userinfo','edituser').'</a></td>';
				}else{
					echo lang('userinfo','edituser').'</td>';
				}
			echo '</tr>';
	}		
	echo '</table><br />';
	
	
	PageFooter();	
		
}
	

function new_user($erred=0, $uf=''){
	global $Cfg;

	PageHeader(lang('adminbar','seeusers_title'), 1);
	PageAnkeiler(lang('userbar','admin') . ' &raquo; ' . lang('adminbar','seeusers_title'));
	if($erred==1) {
		$userfields = $uf;
	}else{
		$userfields = get_userfields(1);	
	}		


	// checkboxes for allowed categories
	$userfields[] = array('heading', "Allowed Categories", '', 8, '', 2);

	$categories = cfg_cats();

	foreach ($categories as $category) {
		$label = sprintf('&nbsp;&nbsp;&nbsp;'.$category);
		$allowed_users = explode("|", $Cfg['cat-'.$category]);
		if (in_array($theuser, $allowed_users)) {
			$userfields[] = array('allowed['.$category.']', $label, '', 2, 1, '', '');
		} else {
			$userfields[] = array('allowed['.$category.']', $label, '', 2, 0, '', '');
		}

	}
	$userfields[(count($userfields)-1)][2]  = 'This user is allowed to post entries in the selected categories'; 

	StartForm('new_user_save', 1);
	StartTable();
	DisplaySettings($userfields);		
	EndForm(lang('userinfo','newuser_button'), 1);		


	PageFooter();		
}


function new_user_save() {
	global $Pivot_Vars, $Cfg, $Users;


	$userfields = get_userfields(1);
	if(CheckInput($Pivot_Vars['username'],3,0)==1){
		$userfields[0][2] = lang('userinfo','username_too_short');
		$Piverr++;
	}elseif(CheckInput($Pivot_Vars['username'],3,0)==0){
		$userfields[0][2] = lang('userinfo','username_not_valid');
		$Piverr++;				
	}

	if(isset($Users[$Pivot_Vars['username']])){
		$userfields[0][2] = lang('userinfo','username_in_use');
		$Piverr++;			
	}
	if((ltrim(rtrim(strtolower($Pivot_Vars['pass1'])))) != (ltrim(rtrim(strtolower($Pivot_Vars['pass2']))))) {
		$userfields[2][2] = lang('userinfo','pass_dont_match');
		$Piverr++;		
	}
	
	if(CheckInput($Pivot_Vars['pass1'],4,0)==1){
		$userfields[1][2] = lang('userinfo','pass_too_short');
		$Piverr++;		
	}	
	
	// if(!(ereg("([[:alnum:]\.\-]+)(\@[[:alnum:]\.\-]+\.+)", $Pivot_Vars['email']))){
	//	$userfields[3][2] = lang('userinfo','not_good_email');
	//	$Piverr++;		
	// }
	
	if($Piverr > 0){
		$userfields[0][4] = $Pivot_Vars['username'];
		$userfields[3][6] = $Pivot_Vars['userlevel'];
		new_user(1, $userfields);
	}else{
		if($Pivot_Vars['userlevel']==3 && ($Pivot_Vars['confirmed']!=1)){
			$vars = array('username', $Pivot_Vars['username'], 'pass1', $Pivot_Vars['pass1'], 'pass2', $Pivot_Vars['pass2'], 'email', $Pivot_Vars['email'], 'userlevel', $Pivot_Vars['userlevel']);
			ConfirmPage(lang('userinfo', 'c_admin_title'), $vars, sprintf(lang('userinfo','c_admin_message'), $Pivot_Vars['username']));	
		}elseif(($Pivot_Vars['userlevel']<3) || ($Pivot_Vars['confirmed']==1)){
			$Users[$Pivot_Vars['username']]['pass'] = md5($Pivot_Vars['pass1']);
			$Users[$Pivot_Vars['username']]['email'] = $Pivot_Vars['email'];
			$Users[$Pivot_Vars['username']]['userlevel'] = $Pivot_Vars['userlevel'];
			$Users[$Pivot_Vars['username']]['language'] = $Pivot_Vars['language'];
			$Users[$Pivot_Vars['username']]['wysiwyg'] = $Pivot_Vars['wysiwyg'];

			$Cfg['users'] .= '|'.$Pivot_Vars['username'];
			
			// set the categories.,
			$cats = cfg_cats();
			foreach ($cats as $category) {
						
				$allowed_users = explode("|", $Cfg['cat-'.$category]);
				if (isset($Pivot_Vars['allowed'][$category])) {
					// add the user..	
					$allowed_users[] = $Pivot_Vars['username'];
					$Cfg['cat-'.$category] = implode("|", $allowed_users);
				}
			}
			
			SaveSettings();
			see_users();
		}
		//they don't really have much choice..
}		
}


function change_user($erred=0, $userfields=''){
	global $Pivot_Vars;
	PageHeader(lang('userinfo','edituser').' "'.$Pivot_Vars['edituser'].'"', 1);
	PageAnkeiler(lang('userbar','admin') . ' &raquo; ' . lang('userinfo','edituser').' "'.$Pivot_Vars['edituser'].'"');

	libchange_user(1, $erred, $userfields);	
	PageFooter();
}



function save_change_user(){

	libsave_change_user(1);	
}


function delete_user() {
		
}

function ipblocks() {
	global $Pivot_Vars, $block;

	
	PageHeader(lang('userbar','admin'). ' &raquo; ' . lang('adminbar','ipblocks'), 1);
	PageAnkeiler(lang('userbar','admin') . ' &raquo; ' . lang('adminbar','ipblocks_title'));
	
	if (isset($Pivot_Vars['blocks'])) {
			
		write_blocks($Pivot_Vars['blocks']);

		$msg = lang('adminbar', 'ipblocks_stored');
		echo "<p><B>$msg</b><br /><br /></p>";
	}

	StartForm('ipblocks', 0);
	StartTable();
	
	$settings = array();
	// $settings[] = array('heading', lang('adminbar','ipblocks_title'), '', 8, '', 2, '');
	$settings[] = array('blocks', lang('adminbar','ipblocks'), '', 5, implode("", $block), '60', 'rows=20');

	DisplaySettings($settings, 'blog_settings');
	EndForm(lang('adminbar', 'ipblocks_store'), 1);		



	PageFooter();

	
}


function fileexplore() {
	global $Pivot_Vars;
	PageHeader(lang('userinfo','edituser').' "'. lang('adminbar','fileexplore_title') .'"', 1);
	PageAnkeiler(lang('userbar','admin') . ' &raquo; ' . lang('adminbar','fileexplore_title'));
	
	include("includes/explorer.txt");


	PageFooter();

	
}


function userfields_main($erred=0, $newdata='') {
	PageHeader(lang('ufield_main','title'), 1);
	PageAnkeiler(lang('userbar','admin') . ' &raquo; ' . lang('adminbar','userfields_title'));	
	MidHeading(lang('ufield_main', 'create'));
	StartForm('new_ufield');		
	StartTable();	
	if($erred==0) {
		$fickle = userfields_array();
	}else{
		$fickle = $newdata;	
	}
	DisplaySettings($fickle , $ufield_item_arr);
	EndForm(lang('ufield_main', 'create'), 1);
	echo '</table>';
	MidHeading(lang('ufield_main', 'edit'));
	
	$ufields = GetUserFields();
	$fields = array();
	foreach($ufields As $key => $val){
		if($key != 'heading'){
			array_push($fields, array($ufields[$key]['disp'], 'ufield_edit&field='.$key, ''));
		}
	}
	DispPage($fields);		
	PageFooter();
}


function userfields_new() {
	global $Pivot_Vars, $Cfg;
	$fts = GetUserFields();
	$fickle = userfields_array();
	if($fts[$Pivot_Vars['intname']]){
		$errout++;
		$fickle[0][2] = lang('ufield_main', 'already');
	}
	if(strlen($Pivot_Vars['intname']) < 3){
		$errout++;
		$fickle[0][2] = lang('ufield_main', 'int');
	}
	if(strlen($Pivot_Vars['disp']) < 3 ){
		$errout++;
		$fickle[1][2] = lang('ufield_main', 'short_disp');				
	}
	if($errout > 0){
		$fickle[0][4] = $Pivot_Vars['intname'];			
		$fickle[1][4] = $Pivot_Vars['disp'];
		$fickle[2][4] = $Pivot_Vars['size'];
		$fickle[3][4] = $Pivot_Vars['maxlen'];
		$fickle[4][6] = $Pivot_Vars['minlevel'];
		userfields_main(1, $fickle);
	}else{
		$fts[$Pivot_Vars['intname']] = 
			Array('type' => 0, 'size' => $Pivot_Vars['size'], 'maxlen' => $Pivot_Vars['maxlen'], 
			'disp' => $Pivot_Vars['disp'], 'minlevel' => $Pivot_Vars['minlevel']
		);
		PutUserFields($fts);
		userfields_main();
			}
}


function userfields_edit($Failed=0, $newdata='') {
	global $ufield_item_arr, $Pivot_Vars;
	PageHeader(lang('ufield_main','title'), 1);
	PageAnkeiler(lang('userbar','admin') . ' &raquo; ' . lang('adminbar','userfields_title'));	
	$ufields = GetUserFields();
	$ufield_arr = userfields_array();
	if($Failed==0){
		$ufield_item_arr['intname'] = $Pivot_Vars['field'];			
		foreach($ufields[$Pivot_Vars['field']] As $item => $val){
			$ufield_item_arr[$item] = $val;
		}
	}else{
		echo "failed at something";
		$ufield_arr = $newdata;
	}
			
	StartForm('editsave_ufield');		
	StartTable();		
	array_push($ufield_arr, 
		array('heading', '', '', 8, '', '2', ''),							
		array('delete', lang('delete'), '', 3, 'yn', '', '0')
	);	
	DisplaySettings($ufield_arr, 'ufield_item_arr');
	EndForm(lang('ufield_main', 'edit'), 1);
	echo '</table>';		
	
}


function userfields_editsave() {
	global $Pivot_Vars, $Cfg;
	$ufield_arr = userfields_array();
	$fts = GetUserFields();	
	if(($Pivot_Vars['confirmed'] != 1) && ($Pivot_Vars['delete'] == 1)){
		$vars = array('intname', $Pivot_Vars['intname'], 'delete', 1);
		ConfirmPage(lang('ufield_main','del_title'), $vars, sprintf(lang('ufield_main','del_desc'), $Pivot_Vars['disp']));
	}elseif(($Pivot_Vars['confirmed'] == 1) && ($Pivot_Vars['delete'] == 1)){
		//go through deleting it.
		unset($Cfg['uf-'.$Pivot_Vars['intname']]);
		foreach(explode("|", $Cfg['userfields']) as $val){
			if($val != $Pivot_Vars['intname']){
				$spoon[] = $val;	
			}
		}
		$Cfg['userfields'] = implode("|", $spoon);	
		//first from the master list
		userfields_main();
	}else{
		if($errout > 0){
			//forget error checking for now..
		}else{
			foreach($ufield_arr as $val){
				if($val[0] != 'intname'){
					$fts[$Pivot_Vars['intname']][$val[0]] = $Pivot_Vars[$val[0]];
				}	
			}
		$Pivot_Vars['field'] = $Pivot_Vars['intname'];
		PutUserFields($fts);
		userfields_main();
		}
	}		
}


function maint_overview() {
	$maint_funcs = array(
		array(lang('adminbar','buildfrontpage'), 'buildfrontpage', lang('adminbar','buildfrontpage_title')),
		array(lang('adminbar','regen'), 'regen', lang('adminbar','regen_title')),
		// array(lang('adminbar','verifydb'), 'verify_db', lang('adminbar','verifydb_title')),
		array(lang('adminbar','buildindex'), 'build_index', lang('adminbar','buildindex_title')),
		// array(lang('adminbar','backup'), 'backup', lang('adminbar','backup_title')),
		array(lang('adminbar','buildsearchindex'), 'build_search', lang('adminbar','buildsearchindex_title')),
		array(lang('adminbar','ipblocks'), 'ipblocks', lang('adminbar','ipblocks_title')),
		array(lang('adminbar','fileexplore'), 'fileexplore', lang('adminbar','fileexplore_title'))
	);
	PageHeader(lang('maint','title'));
	PageAnkeiler(lang('userbar','admin') . ' &raquo; ' . lang('adminbar','maintenance_title'));
	echo '<div style="text-align: center">';
	DispPage($maint_funcs);	
	echo '</div>';
	PageFooter();		
}


function main_blogs($msg="") {
	global $Weblogs;
	PageHeader(lang('adminbar','blogs_title'));
	PageAnkeiler(lang('userbar','admin') . ' &raquo; ' . lang('adminbar','blogs_title'));
	MidHeading(lang('weblog_config','edit_blog'));
	
	if ($msg!="") {
		echo "<br />$msg";
	}

	$send = array();

	foreach ($Weblogs as $key => $weblog) {
		if ($key != "") {
			$send[] = array($Weblogs[$key]['name'], 'blog_edit1&blog='. $key,  lang('weblog_config','edit_weblog'). '\''. $Weblogs[$key]['name'] . '\'');
		}
	}

	$send[] = array('', '', '');

	$send[] = array(lang('weblog_config','new_weblog'), 'blog_edit1', lang('weblog_config','new_weblog_desc'));

	DispPage($send);
			
	PageFooter();
}


function main_blogs_edit1() {
	global $Pivot_Vars, $blog_settings, $Weblogs;
	PageHeader(lang('weblog_config','create_1'));
	PageAnkeiler(lang('userbar','admin') . ' &raquo; ' . lang('weblog_config','create_1'));
	

	if (isset($Pivot_Vars['blog'])) {
		$blog_settings = $Weblogs[$Pivot_Vars['blog']];
		$orig_name = $Pivot_Vars['blog'];

		// option to delete a weblog
		$text = sprintf(lang('weblog_config','del_weblog') .' \'%s\'', $Weblogs[$Pivot_Vars['blog']]['name']);
		$send[] = array($text, 'blog_delete&name='.$Pivot_Vars['blog'] , lang('weblog_config','del_this_weblog'));
		DispPage($send);

		echo "<br />";
		MidHeading(sprintf(lang('weblog_config','edit_weblog') .' \'%s\'', $Weblogs[$Pivot_Vars['blog']]['name']));


	} else {
		$blog_settings = get_tempweblog();
		$orig_name = "";
		MidHeading(lang('weblog_config','create_new'));
	}

	StartForm('blog_edit2', 1);
	StartTable();
	DisplaySettings(get_weblog_config1($orig_name), 'blog_settings');
	EndForm(lang('go'), 1);		
	PageFooter();
}

	
function main_blogs_edit2() {
	global $Cfg, $Pivot_Vars, $blog_settings, $Weblogs, $Current_subweblog;
	PageHeader(lang('weblog_config','create_2'));
	PageAnkeiler(lang('userbar','admin') . ' &raquo; ' . lang('weblog_config','create_2'));
	
	$temp_weblog= array(
		'name' => stripslashes($Pivot_Vars['name']), 
		'payoff' => stripslashes($Pivot_Vars['payoff']),
		'siteurl' => stripslashes($Pivot_Vars['siteurl']),
		'front_filename' => $Pivot_Vars['front_filename'],
		'front_path' => $Pivot_Vars['front_path'],
		'ssi_prefix' => $Pivot_Vars['ssi_prefix'],
		'language' => $Pivot_Vars['language'],

		'live_entries' => $Pivot_Vars['live_entries'],
		'entry_filename' => $Pivot_Vars['entry_filename'],
		'entry_path' => $Pivot_Vars['entry_path'],
		'read_more' => stripslashes($Pivot_Vars['read_more']),
		'archive_filename' => $Pivot_Vars['archive_filename'],
		'archive_path' => $Pivot_Vars['archive_path'],
		'archive_unit' => $Pivot_Vars['archive_unit'],
		'archive_amount' => $Pivot_Vars['archive_amount'],
		'archive_link' => stripslashes($Pivot_Vars['archive_link']),
		'archive_linkfile' => stripslashes($Pivot_Vars['archive_linkfile']),
		'archive_order' => stripslashes($Pivot_Vars['archive_order']),

		'front_template' => $Pivot_Vars['front_template'],
		'archive_template' => $Pivot_Vars['archive_template'],
		'entry_template' => $Pivot_Vars['entry_template'],
		'extra_template' => $Pivot_Vars['extra_template']
	);

	if ( (isset($Pivot_Vars['orig_name'])) && (strlen($Pivot_Vars['orig_name']) > 1) ) {
		$blog_settings = $Weblogs[$Pivot_Vars['orig_name']];
		$orig_name = $Pivot_Vars['orig_name'];
		MidHeading(sprintf(lang('weblog_config','edit_weblog') .' \'%s\'', $Weblogs[$Pivot_Vars['orig_name']]['name']));

	} else {
		$blog_settings = get_tempweblog();
		$orig_name = "";
		MidHeading(lang('weblog_config','create_new'));
	}


	echo lang('weblog_config','subw_heading');

	StartForm('blog_edit3', 1);
	StartTable();

	// initialize the settings array..
	$settings = array();
	$settings[] = array('orig_name', 'originalname', '', 7,  $orig_name);
	$settings[] = array('temp_weblog', 'tempweblog', '', 7,  urlencode(serialize($temp_weblog)));

	$templates = gettemplates('_sub');

	$categories = cfg_cats();

	$template_html = load_template($temp_weblog['front_template']);

	// to cater for users that upgraded their old templates, we 
	// assume [[weblog]] to be [[weblog:standard]]
	$template_html = str_replace("[[weblog]]", "[[weblog:standard]]", $template_html);

	preg_match_all("/\[\[(sub)?weblog:(.*)(:[0-9]*)?\]\]/mUi", $template_html, $match);
	$subweblogs= $match[2];
	

	foreach ($subweblogs as $key) {

		// if the subweblog is in the template, but not in the config files, assume some defaults
		if (!isset($blog_settings['sub_weblog'][$key])) {
			$blog_settings['sub_weblog'][$key]['template']  = "_sub_entry_standard.html";
			$blog_settings['sub_weblog'][$key]['num_entries'] = 10;
			$blog_settings['sub_weblog'][$key]['comments'] = 1;
			$blog_settings['sub_weblog'][$key]['categories'] = array();
		}

		$subweblog = $blog_settings['sub_weblog'][$key];	

		$settings[] = array('heading', $key, '', 8, '', 2);
		$settings[] = array('sub_weblog['.$key.'][template]', lang('weblog_config','shortentry_template'), 
				lang('weblog_config','shortentry_template_desc'), 3, $templates, '', $key);
		$settings[] = array('sub_weblog['.$key.'][num_entries]', lang('weblog_config','num_entries'), 
				lang('weblog_config','num_entries_desc'), 0, $subweblog['num_entries']);
		$settings[] = array('sub_weblog['.$key.'][offset]', lang('weblog_config','offset'), 
				lang('weblog_config', 'offset_desc'), 0, $subweblog['offset']);
		
		$settings[] = array('', 'Publish these categories', '', 6);


		foreach ($categories as $category) {
			$label = sprintf('&nbsp;&nbsp;&nbsp;'.$category);
			if (in_array($category, $subweblog['categories'])) {
				$settings[] = array('sub_weblog['.$key.'][categories]['.$category.']', $label, '', 2, 1, '', '');
			} else {
				$settings[] = array('sub_weblog['.$key.'][categories]['.$category.']', $label, '', 2, 0, '', '');
			}

		}

		$numentries = $blog_settings['sub_weblog'][$key]['num_entries'];

	}

	
	DisplaySettings($settings, 'blog_settings');
	EndForm(lang('go'), 1);		
	PageFooter();
}



function main_blogs_edit3() {
	global $Pivot_Vars, $blog_settings, $Weblogs;
	PageHeader(lang('weblog_config','create_3'));
	PageAnkeiler(lang('userbar','admin') . ' &raquo; ' . lang('weblog_config','create_3'));

	
	if ( (isset($Pivot_Vars['orig_name'])) && (strlen($Pivot_Vars['orig_name']) > 1) ) {
		$blog_settings = $Weblogs[$Pivot_Vars['orig_name']];
		$orig_name = $Pivot_Vars['orig_name'];
		MidHeading(sprintf(lang('weblog_config','edit_weblog') .' \'%s\'', $Weblogs[$Pivot_Vars['orig_name']]['name']));

	} else {
		$blog_settings = get_tempweblog();
		$orig_name = "";
		MidHeading(lang('weblog_config','create_new'));
	}



	
	$temp_subweblogs = $Pivot_Vars['sub_weblog'];

	foreach ($temp_subweblogs as $subweblog => $dummy) {
	
	
		// fix the subweblogs' categories..
		if (count($temp_subweblogs[$subweblog]['categories']) > 0) {
			foreach ($temp_subweblogs[$subweblog]['categories'] as $cat => $dummy) {
				unset ($temp_subweblogs[$subweblog]['categories'][$cat]);
				$temp_subweblogs[$subweblog]['categories'][]=$cat;
			}
		} else {
			// you are an idiot if you did not select any categories..
			$temp_subweblogs[$subweblog]['categories'] = array();
		}
	}

	// unserialize the parsed temp_weblog..
	$temp_weblog = unserialize(urldecode($Pivot_Vars['temp_weblog']));

	// merge temp_weblog with temp_subweblogs
	$temp_weblog['sub_weblog']= $temp_subweblogs;


	StartForm('blog_save', 1);
	StartTable();

	$settings = get_weblog_config3();
	$settings[] = array('orig_name', 'originalname', '', 7,  $orig_name);
	$settings[] = array('temp_weblog', 'tempweblog', '', 7,  urlencode(serialize($temp_weblog)));

	DisplaySettings($settings, 'blog_settings');
	EndForm(lang('weblog_config', 'create'), 1);		
	PageFooter();
}


function main_blog_save() {
	global $Pivot_Vars, $blog_settings, $Weblogs;
	
	// unserialize the parsed temp_weblog..
	$temp_weblog = unserialize(urldecode($Pivot_Vars['temp_weblog']));
	
	if ( (isset($Pivot_Vars['orig_name'])) && (strlen($Pivot_Vars['orig_name']) > 1) ) {
		$orig_name = $Pivot_Vars['orig_name'];
		$msg = lang('weblog_config', 'saved_update');
	} else {
		$orig_name = strtolower(safe_string($temp_weblog['name'],TRUE));
		$msg = lang('weblog_config', 'saved_create');
	}
	

	// add the new stuff
	$temp_weblog['rss'] = $Pivot_Vars['rss'];
		$temp_weblog['rss_filename'] = $Pivot_Vars['rss_filename'];
		$temp_weblog['atom_filename'] = $Pivot_Vars['atom_filename'];
		$temp_weblog['rss_path'] = $Pivot_Vars['rss_path'];
		$temp_weblog['rss_full'] = $Pivot_Vars['rss_full'];

		$temp_weblog['lastcomm_amount'] = $Pivot_Vars['lastcomm_amount'];
		$temp_weblog['lastcomm_length'] = $Pivot_Vars['lastcomm_length'];
		$temp_weblog['lastcomm_format'] = stripslashes($Pivot_Vars['lastcomm_format']);
		$temp_weblog['lastcomm_redirect'] = stripslashes($Pivot_Vars['lastcomm_redirect']);

		$temp_weblog['lastref_amount'] = $Pivot_Vars['lastref_amount'];
		$temp_weblog['lastref_length'] = $Pivot_Vars['lastref_length'];
		$temp_weblog['lastref_format'] = stripslashes($Pivot_Vars['lastref_format']);
		$temp_weblog['lastref_graphic'] = stripslashes($Pivot_Vars['lastref_graphic']);
		$temp_weblog['lastref_redirect'] = stripslashes($Pivot_Vars['lastref_redirect']);

		$temp_weblog['emoticons'] = $Pivot_Vars['emoticons'];
		$temp_weblog['encode_email_addresses'] = $Pivot_Vars['encode_email_addresses'];
		$temp_weblog['target_blank'] = $Pivot_Vars['target_blank'];
		$temp_weblog['fulldate_format'] = stripslashes($Pivot_Vars['fulldate_format']);
		$temp_weblog['entrydate_format'] = stripslashes($Pivot_Vars['entrydate_format']);
		$temp_weblog['diffdate_format'] = stripslashes($Pivot_Vars['diffdate_format']);
		$temp_weblog['comment_sendmail'] = $Pivot_Vars['comment_sendmail'];
		$temp_weblog['comment_emailto'] = $Pivot_Vars['comment_emailto'];
		$temp_weblog['comment_texttolinks'] = $Pivot_Vars['comment_texttolinks'];
		$temp_weblog['comment_wrap'] = $Pivot_Vars['comment_wrap'];
		$temp_weblog['comments_text_0'] = stripslashes($Pivot_Vars['comments_text_0']);
		$temp_weblog['comments_text_1'] = stripslashes($Pivot_Vars['comments_text_1']);
		$temp_weblog['comments_text_2'] = stripslashes($Pivot_Vars['comments_text_2']);
		$temp_weblog['comment_pop'] = $Pivot_Vars['comment_pop'];
		$temp_weblog['comment_width'] = $Pivot_Vars['comment_width'];
		$temp_weblog['comment_height'] = $Pivot_Vars['comment_height'];
		$temp_weblog['comment_format'] = stripslashes($Pivot_Vars['comment_format']);
		$temp_weblog['comment_textile'] = $Pivot_Vars['comment_textile'];

		$temp_weblog['blogroll_id'] = $Pivot_Vars['blogroll_id'];
		$temp_weblog['blogroll_fg'] = $Pivot_Vars['blogroll_fg'];
		$temp_weblog['blogroll_bg'] = $Pivot_Vars['blogroll_bg'];
		$temp_weblog['blogroll_line1'] = $Pivot_Vars['blogroll_line1'];
		$temp_weblog['blogroll_line2'] = $Pivot_Vars['blogroll_line2'];
		$temp_weblog['blogroll_c1'] = $Pivot_Vars['blogroll_c1'];
		$temp_weblog['blogroll_c2'] = $Pivot_Vars['blogroll_c2'];
		$temp_weblog['blogroll_c3'] = $Pivot_Vars['blogroll_c3'];
		$temp_weblog['blogroll_c4'] = $Pivot_Vars['blogroll_c4'];


	$Weblogs[$orig_name] = $temp_weblog;

	save_serialize('pv_cfg_weblogs.php', $Weblogs);

	main_blogs($msg);

}


function main_blog_delete() {
	global $Weblogs, $Pivot_Vars;

	if ($Pivot_Vars['confirmed']!=1) {
			$vars = array('name', $Pivot_Vars['name'], 'blog_delete', 1);
			$msg = lang('weblog_config', 'confirm_delete');
			$msg = str_replace("%1", $Pivot_Vars['name'], $msg);
			ConfirmPage(lang('ufield_main','del_title'), $vars, $msg);
	} else {
		$name = $Pivot_Vars['name'];
		unset($Weblogs[$name]);
		save_serialize('pv_cfg_weblogs.php', $Weblogs);	
		$msg = lang('weblog_config', 'deleted');
		main_blogs($msg);

	}
}

?>
